from __future__ import with_statement

import sys, os, re, glob

release   = prop('release',   '0.1.1')
package   = 'picotest'
copyright = 'copyright(c) 2011 kuwata-lab.com all rights reserved'
license   = 'MIT License'

kookbook.default = "test"

node_path = os.environ.get('NODE_PATH')
if not node_path:
    node_path = os.path.dirname(os.path.abspath(__file__))
    os.environ['NODE_PATH'] = os.path.join(node_path, 'lib')


nodejs = "node --strict_mode"

dist_dir = 'dist-' + release


@recipe
def test(c):
    """do test"""
    #system(c%"$(nodejs) math_test.js")
    with chdir("test"):
        for fname in glob.glob("*_test.js"):
            system(c%"$(nodejs) $(fname)")


text_files = [ 'README.txt', 'CHANGES.txt', 'MIT-LICENSE', 'Kookbook.py', 'package.json' ];

def dist_dir():
    return "dist/%s-%s" % (package, release)


@recipe
@ingreds('dist')
def publish(c):
    """upload package; you must do 'npm adduser' in advance"""
    dir = dist_dir()
    with chdir(dir):
        system("npm publish .")


@recipe
def dist(c):
    """create 'dist' directory and copy files to it"""
    dir = dist_dir()
    rm_rf(dir)
    mkdir_p(dir)
    #
    store(text_files, dir)
    store("lib/*.js", "test/*.js", "examples/*.js", dir)
    #
    #mkdir(c%'$(dir)/bin');
    #cp("lib/picotest.js", c%'$(dir)/bin/picotest.js');
    #system(c%'chmod 0755 $(dir)/bin/picotest.js')
    #
    replacer = [
        (r'\$Release:.*?\$',   r'$Release: %s $'   % release),
        (r'\$Copyright:.*?\$', r'$Copyright: %s $' % copyright),
        (r'\$License:.*?\$',   r'$License: %s $'   % license),
        (r'\$Release\$',   release),
        (r'\$Copyright\$', copyright),
        (r'\$License\$',   license),
    ]
    edit(c%'$(dir)/**/*', by=replacer)
    cp('Kookbook.py', dir)   # don't edit 'Kookbook.py'
