///
/// Example of PicoTest.js
///

var assert = require("assert");

exports["example_test.js"] = {

    /// grouping test
    "Example1": {
        "1+1 should be 2": function() {
            assert.equal(1+1, 2);
        },
        "1-1 should be 0": function() {
            assert.equal(1-1, 0);
        }
    },

    /// nestable test
    "Example2": {
        "Example2-1": {
            "Example2-1-1": {
                "2*2 should be 4": function() {
                    assert.equal(2*2, 4);
                },
                "3*3 should be 9": function() {
                    assert.equal(3*3, 9);
                }
            }
        }
    },

    /// fixtures
    "Example3": {
        "BEFORE": function() {   // setup
            this.x = 10;
            this.y = 20;
        },
        "AFTER": function() {    // teardown
        },
        "x+y should be 30": function() {
            assert.equal(this.x + this.y, 30);
        }
    }

};

/// run tests
if (require.main === module) {
    require("picotest").run(exports);     // xUnit style
    /// or
    //require("picotest").tap(exports);   // TAP style
}
